%define qthreads_archs i386 sparc
# Once 'as' is fixed on alpha, that arch should be added to qthreads_archs

Name:           compat-guile-16
Version:        1.6.7
Release:        8%{?dist}
Summary:        A GNU implementation of Scheme for application extensibility

License:        GPLv2
Group:          Development/Languages
URL:            http://www.gnu.org/software/guile

Source:         ftp://ftp.gnu.org/gnu/guile-%{version}.tar.gz
Source2:        http://ai.king.net.pl/guile-1.6-missing-tools.tar.gz

Patch1:         guile-1.6.7-rpath.patch
Patch2:         guile-1.6.0-unknown_arch.patch
Patch3:         guile-1.6.0-ppc64.patch
Patch4:         guile-1.6.7-ltdl.patch
Patch5:         guile-1.6.7-64bit.patch
Patch6:         guile-1.6.7-noexecstack.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  libtool, libtool-ltdl-devel, readline-devel
Requires:       slib >= 3a1-1

%description
GUILE (GNU's Ubiquitous Intelligent Language for Extension) is a library
implementation of the Scheme programming language, written in C.  GUILE
provides a machine-independent execution platform that can be linked in
as a library during the building of extensible programs.

This is a compatibility package for the old guile version 1.6.

%package devel
Summary: Header files for the GUILE extensibility library
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}, automake


%description -n %{name}-devel
The %{name}-devel package contains the header files for the GUILE
libraries.

This is a compatibility package for the old guile version 1.6.


%prep
%setup -q -n guile-%{version}
%patch1 -p1 -b .rpath6
%patch2 -p1 -b .unknown_arch
%patch3 -p1 -b .ppc64
%patch4 -p1 -b .ltdl
%patch5 -p1 -b .64bit
%patch6 -p1 -b .noexecstack


%build

WITH_THREADS=--with-threads
%ifnarch %{qthreads_archs}
WITH_THREADS=
%endif

%ifarch ia64
export CFLAGS="$RPM_OPT_FLAGS -O0"
%endif
%configure --disable-static $WITH_THREADS

# Multilib fix for procedures.txt
perl -pi -e 's|threads.doc||' `find . -name Makefile`

%{__make} %{?_smp_mflags} -C libguile scmconfig.h
# Ouch! guile forgets to set its own shared lib path to use shared uninstalled
# apps. It ain't pretty, but it works.
LD_LIBRARY_PATH="`pwd`/libguile/.libs:`pwd`/qt/.libs:`pwd`/libguile-ltdl/.libs" \
    %{__make} LDFLAGS="-L`pwd`/libguile/.libs" %{?_smp_mflags}

# Compression should be here for --short-circult
# Compress large documentation
bzip2 NEWS

%install
%{__rm} -rf %{buildroot}

# Convince guile to be packaged.
perl -p -i -e "s|^libdir.*|libdir='%{buildroot}%{_libdir}'|g" \
        guile-readline/libguilereadline.la

perl -p -i -e "s|^relink_command.*||g" guile-readline/libguilereadline.la

%{__make} INSTALL="install -p" install DESTDIR=%{buildroot}

# Fix up libtool libraries.
find %{buildroot} -name '*.la' | \
  xargs perl -p -i -e "s|%{buildroot}||g"

chmod 0755 %{buildroot}%{_libdir}/libguile.so.*
ln -s ../../share/slib %{buildroot}%{_datadir}/guile/slib


# Install additional scripts
tar zxvf %{SOURCE2}
pushd guile-1.6-missing-tools
%{__cp} -ap scripts/* %{buildroot}%{_datadir}/guile/1.6/scripts
chmod 0755 %{buildroot}%{_datadir}/guile/1.6/scripts/*
%{__cp} -ap ice-9/* %{buildroot}%{_datadir}/guile/1.6/ice-9
popd

%{__mv} %{buildroot}%{_bindir}/guile %{buildroot}%{_bindir}/guile-1.6
%{__mv} %{buildroot}%{_bindir}/guile-tools %{buildroot}%{_bindir}/guile-tools-1.6
%{__mv} %{buildroot}%{_bindir}/guile-config %{buildroot}%{_bindir}/guile-config-1.6
%{__mv} %{buildroot}%{_bindir}/guile-snarf %{buildroot}%{_bindir}/guile-snarf-1.6
sed -i "s|%{_bindir}/guile|%{_bindir}/guile-1.6|" %{buildroot}%{_bindir}/guile-config-1.6
sed -i 's|-lguile |-lguile16 |' %{buildroot}%{_bindir}/guile-config-1.6

# Remove unpackaged files
%{__rm} -f %{buildroot}%{_bindir}/guile-{doc-snarf,func-name-check,snarf.awk}
%{__rm} -rf %{buildroot}%{_includedir}/guile-readline
%{__rm} -rf %{buildroot}%{_datadir}/info
%{__rm} -f %{buildroot}%{_libdir}/*.{a,la}

# Prevents conflicts with guile-devel
%{__mv} %{buildroot}%{_includedir}/guile %{buildroot}%{_includedir}/guile16
%{__mv} %{buildroot}%{_includedir}/libguile %{buildroot}%{_includedir}/libguile16
%{__mv} %{buildroot}%{_includedir}/libguile.h %{buildroot}%{_includedir}/libguile16.h
%{__mv} %{buildroot}%{_datadir}/aclocal/guile.m4 %{buildroot}%{_datadir}/aclocal/guile16.m4
%{__mv} %{buildroot}%{_libdir}/libguile.so %{buildroot}%{_libdir}/libguile16.so
sed -i "s|libguile|libguile16|" %{buildroot}%{_includedir}/libguile16.h
sed -i "s|libguile|libguile16|" %{buildroot}%{_includedir}/guile16/gh.h
sed -i "s|libguile|libguile16|" `find  %{buildroot}%{_includedir}/libguile16 -name '*.h'`

%clean
%{__rm} -rf %{buildroot}


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING ChangeLog GUILE-VERSION README
%{_bindir}/guile-1.6
%{_bindir}/guile-tools-1.6
%{_libdir}/lib*.so.*
%{_datadir}/guile/1.6
%{_datadir}/guile/slib


%files devel
%doc HACKING NEWS.bz2 THANKS SNAPSHOTS ANON-CVS
%defattr(-,root,root,-)
%{_bindir}/guile-config-1.6
%{_bindir}/guile-snarf-1.6
%{_libdir}/lib*.so
%{_includedir}/guile16
%{_includedir}/libguile16
%{_includedir}/libguile16.h
%{_datadir}/aclocal/guile16.m4


%Changelog
* Thu Aug 23 2007 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> - 1.6.7-7
- Rebuild for Fedora 8

* Sat Jan 13 2007 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> - 1.6.7-6
- fix for ppc arch

* Wed Jan 10 2007 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> - 1.6.7-5
- Added automake in requires
- some minor corrections

* Sun Jan 07 2007 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> - 1.6.7-4
- Added automake in BR

* Sat Jan 06 2007 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.6.7-3.1
- Naming rule change, especially for libraries/header files.
- Move two scripts to -devel.

* Wed Dec 13 2006 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> - 1.6.7-3
- take over the ownership of this package
- added timestamps during make install
- dropped the compat-libguile package
- clean ups

* Thu Dec  7 2006 Gerard Milmeister <gemi@bluewin.ch> - 1.6.7-2
- clean up spec

* Mon Dec  4 2006 Gerard Milmeister <gemi@bluewin.ch> - 1.6.7-1
- make compability package

* Tue Feb 28 2006 Miroslav Lichvar <mlichvar@redhat.com> - 5:1.6.7-6
- move .la files for modules from devel to main package (#182242)

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 5:1.6.7-5.2
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 5:1.6.7-5.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Mon Feb 06 2006 Miroslav Lichvar <mlichvar@redhat.com> 5:1.6.7-5
- Avoid marking qthreads library as requiring executable stack (#179274)

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Fri Sep 02 2005 Phil Knirsch <pknirsch@redhat.com> 5:1.6.7-4
- Fix dynamic linking on 64bit archs (#159971)

* Wed Mar 02 2005 Phil Knirsch <pknirsch@redhat.com> 5:1.6.7-2
- bump release and rebuild with gcc 4
- Fixed problem with ltdl and gcc 4 rebuild
- Add BuildPreReq for libtool-ltdl-devel

* Wed Feb 09 2005 Phil Knirsch <pknirsch@redhat.com> 5:1.6.7-1
- Update to guile-1.6.7
- Dropped ia64 patch, stuff looks fixed in upstream code

* Wed Jan 12 2005 Phil Knirsch <pknirsch@redhat.com> 5:1.6.4-18
- rebuilt because of new readline

* Thu Dec 23 2004 Phil Knirsch <pknirsch@redhat.com> 5:1.6.4-17
- Fixed wrong post and postun use of /sbin/ldconfig (#143657)

* Tue Dec 21 2004 Phil Knirsch <pknirsch@redhat.com> 5:1.6.4-16
- Moved info files to base package as they are not devel related (#139948)
- Moved static guilereadline and guile-srfi-srfi libs to devel package (#140893)
- Fixed guile-tools not finding guile lib dir (#142642)
- Added some nice tools (#142642)
- Removed smp build, seems to be broken atm

* Wed Dec  8 2004 Jindrich Novy <jnovy@redhat.com> 5:1.6.4-15
- remove dependency to umb-scheme and replace it by slib

* Tue Oct 12 2004 Phil Knirsch <pknirsch@redhat.com> 5:1.6.4-14
- Fix multilib support for guile

* Tue Aug 03 2004 Phil Knirsch <pknirsch@redhat.com>  5:1.6.4-13
- Enable optimization again for s390.

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Apr 16 2004 Warren Togami <wtogami@redhat.com> 5:1.6.4-11
- Fix post failure and duplicate rpm in database
- Compress NEWS
- other minor cleanups

* Wed Apr 14 2004 Phil Knirsch <pknirsch@redhat.com> 5:1.6.4-10
- Fixed info file stuff (#112487)

* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Aug 27 2003 Bill Nottingham <notting@redhat.com> 5:1.6.4-8.2
- rebuild (#103148)

* Tue Aug 19 2003 Phil Knirsch <pknirsch@redhat.com> 5:1.6.4-8.1
- rebuilt

* Tue Aug 19 2003 Phil Knirsch <pknirsch@redhat.com> 5:1.6.4-8
- Moved dynamic loadable libraries out file devel into main (#98392).

* Wed Jul 02 2003 Phil Knirsch <pknirsch@redhat.com> 5:1.6.4-7.1
- rebuilt

* Wed Jul 02 2003 Phil Knirsch <pknirsch@redhat.com> 5:1.6.4-7
- Added srfi libs (#98392).

* Sun Jun  8 2003 Tim Powers <timp@redhat.com> 5:1.6.4-6.1
- add epoch for versioned requires
- built for RHEL

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri May 16 2003 Phil Knirsch <pknirsch@redhat.com> 5:1.6.4-5
- Bumped release and rebuilt.

* Fri May 16 2003 Phil Knirsch <pknirsch@redhat.com> 5:1.6.4-4
- Install and package info files, too.

* Fri May 16 2003 Phil Knirsch <pknirsch@redhat.com> 5:1.6.4-3
- Bumped release and rebuilt.

* Fri May 16 2003 Phil Knirsch <pknirsch@redhat.com> 5:1.6.4-2
- Fixed .la file problem, moved from devel to normal package.

* Tue May 06 2003 Phil Knirsch <pknirsch@redhat.com> 5:1.6.4-1
- Update to 1.6.4

* Thu Feb 13 2003 Elliot Lee <sopwith@redhat.com> 5:1.6.0-5
- Patch7 - fix for ppc64
- Fix qthreads dealie, including actually enabling them

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Fri Dec 06 2002 Phil Knirsch <pknirsch@redhat.com> 5:1.6.0-3
- Included s390 as working arch as well, switch to general unknown arch patch

* Tue Dec  3 2002 Tim Powers <timp@redhat.com> 5:1.6.0-2
- rebuild to fix broken deps
- fix continuations.h on ia64

* Tue Dec 03 2002 Phil Knirsch <pknirsch@redhat.com> 1.6.0-1
- Make it build on x86_64.
- Integrated and fixed Than's update to 1.6.0.
- Fixed some things in the %%files section.

* Mon Nov 11 2002 Than Ngo <timp@redhat.com> 1.4.1-2
- fix to build on s390*/x86_64 -> include libguilereadline.so
- fix to link libltdl
- don't use rpath

* Thu Nov 07 2002 Phil Knirsch <pknirsch@redhat.com> 1.4.1-1
- Updated to guile-1.4.1
- libguilereadline.so doesn't work on x86_64 yet, so don't package it.

* Wed Nov 06 2002 Phil Knirsch <pknirsch@redhat.com> 1.4-10
- Fixed unpackaged files.

* Tue Nov  5 2002 Bill Nottingham <notting@redhat.com> 1.4-9
- Remove qthread from x86_64 as well.

* Wed Jul 17 2002 Phil Knirsch <pknirsch@redhat.com> 1.4-8
- Remove qthread from ppc as well.

* Wed Jul 10 2002 Phil Knirsch <pknirsch@redhat.com> 1.4-7
- Fixed some more %%files lib related errors ().

* Fri Jun 21 2002 Tim Powers <timp@redhat.com> 1.4-6
- automated rebuild

* Wed Jun 19 2002 Phil Knirsch <pknirsch@redhat.com> 1.4-5
- Don't forcibly strip binaries

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon May 06 2002 Florian La Roche <Florian.LaRoche@redhat.de>
- adjust for mainframe and alpha

* Fri Jan 25 2002 Bill Nottingham <notting@redhat.com>
- ship qthread devel links too

* Fri Jan 25 2002 Phil Knirsch <pknirsch@redhat.com>
- Update again to 1.4.
- Disable --with-threads for IA64 as it doesn't work.

* Thu Jan 24 2002 Phil Knirsch <pknirsch@redhat.com> 1.3.4-17/4
- Enabled --with-threads and removed --enable-dynamic-linking for configure
  (bug #58597)

* Mon Sep  3 2001 Philipp Knirsch <pknirsch@redhat.de> 1.3.4-16/3
- Fixed problem with read-only /usr pollution of /usr/share/umb-scheme/slibcat
  (#52742)

* Wed Aug 22 2001 Philipp Knirsch <pknirsch@redhat.de> 1.3.4-15/2
- Fixed /tmp buildroot pollution (#50398)

* Mon Jun 12 2001 Florian La Roche <Florian.LaRoche@redhat.de> 1.3.4-14/1
- size_t patch from <oliver.paukstadt@millenux.com>

* Fri May 11 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.3.4-13/1
- Rebuild with new readline

* Wed Feb 28 2001 Philipp Knirsch <pknirsch@redhat.de>
- Fixed missing devel version dependancy.
- Fixed bug #20134 for good this time.

* Mon Jan 22 2001 Than Ngo <than@redhat.com>
- disable optimization on ia64 (compiler bug) (bug #23186)

* Tue Dec 12 2000 Philipp Knirsch <Philipp.Knirsch@redhat.de>
- Fixed %%files bug #20134 where the /usr/lib/libguilereadline.so didn't get
  installed for the non devel version.

* Fri Jul 14 2000 Nalin Dahyabhai <nalin@redhat.com>
- Add version number to prereq for umb-scheme to get the post-install to
  work properly.

* Thu Jul 13 2000 Nalin Dahyabhai <nalin@redhat.com>
- Add an Epoch = 1 in case anyone happened to have 1.4 installed.

* Thu Jul 13 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Tue Jul 11 2000 Nalin Dahyabhai <nalin@redhat.com>
- Back down to 1.3.4.
- Fix to actually link against the version of libguile in the package.

* Sun Jun  4 2000 Nalin Dahyabhai <nalin@redhat.com>
- FHS fixups using the %%{makeinstall} macro.

* Sun Mar 26 2000 Florian La Roche <Florian.LaRoche@redhat.com>
- fix preun-devel
- call ldconfig directly in postun

* Fri Mar 24 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- rebuild with new readline
- update to 1.3.4

* Mon Feb 28 2000 Nalin Dahyabhai <nalin@redhat.com>
- using the same catalog as umb-scheme makes umb-scheme a prereq

* Thu Feb 17 2000 Florian La Roche <Florian.LaRoche@redhat.com>
- readline is needed for %%post

* Tue Feb  8 2000 Nalin Dahyabhai <nalin@redhat.com>
- use the same catalog as umb-scheme

* Thu Sep  2 1999 Jeff Johnson <jbj@redhat.com>
- fix broken %%postun

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com>
- auto rebuild in the new build environment (release 6)

* Wed Mar 17 1999 Michael Johnson <johnsonm@redhat.com>
- added .ansi patch to fix #endif

* Wed Feb 10 1999 Cristian Gafton <gafton@redhat.com>
- add patch for the scm stuff

* Sun Jan 17 1999 Jeff Johnson <jbj@redhat.com>
- integrate changes from rhcn version (#640)

* Tue Jan 12 1999 Cristian Gafton <gafton@redhat.com>
- call libtoolize first to get it to compile on the arm

* Sat Jan  9 1999 Todd Larason <jtl@molehill.org>
- Added "Requires: guile" at suggestion of Manu Rouat <emmanuel.rouat@wanadoo.fr>

* Fri Jan  1 1999 Todd Larason <jtl@molehill.org>
- guile-devel does depend on guile
- remove devel dependancy on m4
- move guile-snarf from guile to guile-devel
- Converted to rhcn

* Wed Oct 21 1998 Jeff Johnson <jbj@redhat.com>
- update to 1.3.
- don't strip libguile.so.*.0.0. (but set the execute bits).

* Thu Sep 10 1998 Cristian Gafton <gafton@redhat.com>
- spec file fixups

* Wed Sep  2 1998 Michael Fulbright <msf@redhat.com>
- Updated for RH 5.2

* Mon Jan 26 1998 Marc Ewing <marc@redhat.com>
- Started with spec from Tomasz Koczko <kloczek@idk.com.pl>
- added slib link

* Thu Sep 18 1997 Tomasz Koczko <kloczek@idk.com.pl>          (1.2-3)
- added %%attr(-, root, root) for %%doc,
- in %%post, %%postun ldconfig runed as parameter "-p",
- removed /bin/sh from requires,
- added %%description,
- changes in %%files.

* Fri Jul 11 1997 Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl>  (1.2-2)
- all rewrited for using Buildroot,
- added %%postun,
- removed making buid logs,
- removed "--inclededir", added "--enable-dynamic-linking" to configure
  parameters,
- added striping shared libs and /usr/bin/guile,
- added "Requires: /bin/sh" (for guile-snarf) in guile package and
  "Requires: m4" for guile-devel,
- added macro %%{PACKAGE_VERSION} in "Source:" and %%files,
- added %%attr macros in %%files.
